// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlPreferencesBin")]
    pub struct PreferencesBin(Object<ffi::DzlPreferencesBin, ffi::DzlPreferencesBinClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_preferences_bin_get_type(),
    }
}

impl PreferencesBin {
    pub const NONE: Option<&'static PreferencesBin> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::PreferencesBin>> Sealed for T {}
}

pub trait PreferencesBinExt: IsA<PreferencesBin> + sealed::Sealed + 'static {
    fn keywords(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "keywords")
    }

    fn path(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "path")
    }

    fn priority(&self) -> i32 {
        ObjectExt::property(self.as_ref(), "priority")
    }

    #[doc(alias = "schema-id")]
    fn schema_id(&self) -> Option<glib::GString> {
        ObjectExt::property(self.as_ref(), "schema-id")
    }

    #[doc(alias = "preference-activated")]
    fn connect_preference_activated<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn preference_activated_trampoline<
            P: IsA<PreferencesBin>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlPreferencesBin,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(PreferencesBin::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"preference-activated\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    preference_activated_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<PreferencesBin>> PreferencesBinExt for O {}

impl fmt::Display for PreferencesBin {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("PreferencesBin")
    }
}
